% $Id: genEscherGecko.m,v 1.5 2014/12/14 16:07:08 aaron Exp aaron $
% this works on refined escher gecko, with repeated line segment
% vertices on ideal 100 unit radius hexagon
function gg = genEscherGecko(g,forceSymmetry)
%g = load('EscherGecko5.dat');
if (nargin < 2), forceSymmetry = 0; end

gg=g;gg(:,3)=1;

c = cosd(120);  % all rotations are 120 deg.  tri-lateral symmetry
s = sind(120);

% fixed points, at end of line segments, defines segment order:
len = 100;  % length of hex edges and vertex radius
x0 = len * cosd(30); % flat radius
y0 = len * sind(30);
fixedPoints = [0 len;x0 y0;x0 -y0;0 -len;-x0 -y0; -x0 y0];
fixedPoints = [fixedPoints;fixedPoints(1,:)]; % repeat first point to close polygon loops

% define rotation mappings between segments
map.r16 = [c  s   -x0;-s c  3*y0];% mapping from segment 1 to segment 6
map.r61 = [c -s    x0; s c  3*y0];
map.r32 = [c  s  2*x0;-s c    0 ];
map.r23 = [c -s    x0; s c -3*y0];
map.r45 = [c -s -2*x0; s c    0 ];
map.r54 = [c  s   -x0;-s c -3*y0];

[segEnd,seg] = findSegmentDefinitions(gg,fixedPoints);


% set segments 6,3,5 by symmetry from segments 1,2,4 respectively
if (forceSymmetry)
  gg = setBySymmetry124(gg,segEnd,map);
  [segEnd,seg] = findSegmentDefinitions(gg,fixedPoints); % check if segments changed
  gg(:,3)=1;
end

% refines imperfect symmetry, but also makes nice plots
gg=refineGeckoSymmetry(gg,fixedPoints,map);
end
% $Log: genEscherGecko.m,v $
% Revision 1.5  2014/12/14 16:07:08  aaron
% functionized.  option to use symmetry from segments 124 instead of refine
%
% Revision 1.4  2014/12/13 17:23:41  aaron
% added example of setting half of the segments by pure symmetry
%
% Revision 1.3  2014/12/13 16:28:30  aaron
% switch to automated location of segment endpoints

