% $Id: genEscherGecko.m,v 1.5 2014/12/14 16:07:08 aaron Exp aaron $
% this uses an Escher gecko-like symmetry, but on a square
% rather than a hexagon
% vertices on ideal 100 unit radius square
function gg = genSquareTess(g,forceSymmetry)
%g = load('EscherGecko5.dat');
if (nargin < 2), forceSymmetry = 1; end

gg=g;gg(:,3)=1;

% fixed points, at end of line segments, defines segment order:
len = 100;  % length of hex edges and vertex radius
fixedPoints = len * [-1 1;1 1;1 -1;-1 -1];
fixedPoints = [fixedPoints;fixedPoints(1,:)]; % repeat first point to close polygon loops

% define rotation mappings between segments
map.r14 = [0  1 -len;-1 0  len];% mapping from segment 1 to segment 4
map.r41 = [0 -1  len; 1 0  len];
map.r23 = [0  1  len;-1 0   0 ];
map.r32 = [0 -1  len; 1 0 -len];

[segEnd,seg] = findSegmentDefinitions(gg,fixedPoints);


% set segments 6,3,5 by symmetry from segments 1,2,4 respectively
if (forceSymmetry)
  gg = setBySymmetry12(gg,segEnd,map);
  [segEnd,seg] = findSegmentDefinitions(gg,fixedPoints); % check if segments changed
  gg(:,3)=1;
end

% refines imperfect symmetry, but also makes nice plots
gg=refineGeckoSymmetry(gg,fixedPoints,map);
end
% $Log: genEscherGecko.m,v $
% Revision 1.5  2014/12/14 16:07:08  aaron
% functionized.  option to use symmetry from segments 124 instead of refine
%
% Revision 1.4  2014/12/13 17:23:41  aaron
% added example of setting half of the segments by pure symmetry
%
% Revision 1.3  2014/12/13 16:28:30  aaron
% switch to automated location of segment endpoints

