% $Id: refineGeckoSymmetry.m,v 1.1 2014/12/14 16:06:40 aaron Exp aaron $
% Refine and check gecko symmetry and plot

function gg=refineGeckoSymmetry(gg0,fixedPoints,map)
gg = gg0;
[segEnd,seg] = findSegmentDefinitions(gg,fixedPoints);

hold off;plot(gg(:,1),gg(:,2),'bo-');grid on; axis equal;hold on

% make sure segments ends fall on defined fixed hexagon vertices
gg=setFixedPoints(gg,segEnd,fixedPoints);

plot(gg(segEnd,1), gg(segEnd,2), 'y', 'LineWidth', 5);

% mapping from segment 1 to segment 6
%r16 = [c s -86.6;-s c 150];
gg = updateMappedSegment(gg,map.r16,seg{1},seg{6},'c',[1 .5 .5]);
gg=setFixedPoints(gg,segEnd,fixedPoints);

%r61 = [c -s 86.6; s c 150];
gg = updateMappedSegment(gg,map.r61,seg{6},seg{1},'g',[1 .7 .3]);
gg=setFixedPoints(gg,segEnd,fixedPoints);

%r32= [c s 2*86.6;-s c 0];
gg = updateMappedSegment(gg,map.r32,seg{3},seg{2},'c',[0 .7 .3]);
gg=setFixedPoints(gg,segEnd,fixedPoints);

%r23 = [c -s 86.6; s c -150];
gg = updateMappedSegment(gg,map.r23,seg{2},seg{3},'g',[0 .3 1]);
gg=setFixedPoints(gg,segEnd,fixedPoints);

%r45 = [c -s -2*86.6; s c 0];
gg = updateMappedSegment(gg,map.r45,seg{4},seg{5},'g',[.2 .8 .3]);
gg=setFixedPoints(gg,segEnd,fixedPoints);

%r54 = [c s -86.6;-s c -150];
gg = updateMappedSegment(gg,map.r54,seg{5},seg{4},'c',[.2 .8 .3]);
gg=setFixedPoints(gg,segEnd,fixedPoints);

end
% $Log: refineGeckoSymmetry.m,v $
% Revision 1.1  2014/12/14 16:06:40  aaron
% Initial revision
%
% extracted main part of genEscherGecko into proper function
