% this works on refined escher gecko, with repeated line segment
% vertices on ideal 100 unit radius hexagon
g = load('EscherGecko3.dat');
gg=g;gg(:,3)=1;
hold off;plot(gg(:,1),gg(:,2),'bo-');grid on; axis equal;hold on

c = cosd(120);  % all rotations are 120 deg.  tri-lateral symmetry
s = sind(120);

% segment definitions
segEnd = [1 10 16 22 31 40 49];
seg{1} = [segEnd(1):segEnd(2)];
seg{2} = [segEnd(2):segEnd(3)];
seg{3} = [segEnd(3):segEnd(4)];
seg{4} = [segEnd(4):segEnd(5)];
seg{5} = [segEnd(5):segEnd(6)];
seg{6} = [segEnd(6):segEnd(7)];

gg=setFixedPoints(gg,segEnd);  % make sure segments ends fall on ideal hexagon
plot(gg(segEnd,1), gg(segEnd,2), 'y', 'LineWidth', 5);

% mapping from segment 1 to segment 6
r16 = [c s -86.6;-s c 150];
gg = updateMappedSegment(gg,r16,seg{1},seg{6},'c',[1 .5 .5]);
gg=setFixedPoints(gg,segEnd);  % make sure segments ends fall on ideal hexagon

r61 = [c -s 86.6; s c 150];
gg = updateMappedSegment(gg,r61,seg{6},seg{1},'g',[1 .7 .3]);
gg=setFixedPoints(gg,segEnd);  % make sure segments ends fall on ideal hexagon

r32= [c s 2*86.6;-s c 0];
gg = updateMappedSegment(gg,r32,seg{3},seg{2},'c',[0 .7 .3]);
gg=setFixedPoints(gg,segEnd);  % make sure segments ends fall on ideal hexagon

r23 = [c -s 86.6; s c -150];
gg = updateMappedSegment(gg,r23,seg{2},seg{3},'g',[0 .3 1]);
gg=setFixedPoints(gg,segEnd);  % make sure segments ends fall on ideal hexagon

r45 = [c -s -2*86.6; s c 0];
gg = updateMappedSegment(gg,r45,seg{4},seg{5},'g',[.2 .8 .3]);
gg=setFixedPoints(gg,segEnd);  % make sure segments ends fall on ideal hexagon

r54 = [c s -86.6;-s c -150];
gg = updateMappedSegment(gg,r54,seg{5},seg{4},'c',[.2 .8 .3]);
gg=setFixedPoints(gg,segEnd);  % make sure segments ends fall on ideal hexagon
